/*** MODULE DCDEF ***/
/*                                                                          */
/* DEVICE ADAPTER, CLASS, AND TYPE DEFINITIONS                              */
/*                                                                          */
/*                                                                          */
/* DEFINE ADAPTER TYPES                                                     */
/*                                                                          */
/*									    */
#define AT$_MBA 	0x00		/* MASSBUS ADAPTER                  */
#define AT$_UBA 	0x01		/* UNIBUS ADAPTER                   */
#define AT$_DR 		0x02            /* DR32 ADAPTER                     */
#define AT$_MPM 	0x03		/* MULTI-PORT MEMORY                */
#define AT$_CI 		0x04		/* CI BUS                           */
#define AT$_NULL 	0x05		/* NULL (SOFTWARE) ADAPTER          */
#define AT$_BDA 	0x06		/* BI DISK ADAPTER(KDB50)           */
/*                                                                          */
/* DEFINE DEVICE CLASSES                                                    */
/*                                                                          */
/*DEFINE DEVICE CLASSES                                                     */
#define DC$_DISK 	0x01            /* DISK                             */
#define DC$_TAPE 	0x02		/* TAPES                            */
#define DC$_SCOM 	0x20		/* SYNCHRONOUS COMMUNICATIONS DEVICES  */
#define DC$_CARD 	0x41		/* CARD READER                      */
#define DC$_TERM 	0x42		/* TERMINAL                         */
#define DC$_LP 		0x43		/* LINE PRINTER                     */
#define DC$_WORKSTATION 0x46		/* WORKSTATIONS                     */
#define DC$_REALTIME 	0x60		/* REAL-TIME                        */
#define DC$_BUS 	0x80		/* BUSES, E.G, CI                   */
#define DC$_MAILBOX 	0xA0		/* MAILBOX                          */
#define DC$_JOURNAL	0xA1		/* JOURNAL			    */
#define DC$_MISC 	0xC8		/* MISCELLANEOUS DEVICES            */
/*                                                                          */
/* DEFINE DEVICE TYPES                                                      */
/*                                                                          */
/*                                                                          */
/*                                                                          */
/* DISK DEVICES                                                             */
/*                                                                          */
#define DT$_RK06 	0x01		/*RK06 DISK                         */
#define DT$_RK07 	0x02		/*RK07 DISK                         */
#define DT$_RP04 	0x03		/*RP04 DISK                         */
#define DT$_RP05 	0x04		/*RP05 DISK                         */
#define DT$_RP06 	0x05		/*RP06 DISK                         */
#define DT$_RM03 	0x06		/*RM03 DISK                         */
#define DT$_RP07 	0x07		/*RP07 DISK                         */
#define DT$_RP07HT 	0x08		/*RP07 DISK WITH HEAD/TRACK         */
#define DT$_RL01 	0x09		/*RL01 DISK                         */
#define DT$_RL02 	0x0A		/*RL02 DISK                         */
#define DT$_RX02 	0x0B		/*RX02 DISK                         */
#define DT$_RX04 	0x0C		/*RX04 DISK                         */
#define DT$_RM80 	0x0D		/*RM80 DISK                         */
#define DT$_TU58 	0x0E		/*TU58                              */
#define DT$_RM05 	0x0F		/*RM05 DISK                         */
#define DT$_RX01 	0x10		/*RX01 DISK                         */
#define DT$_ML11 	0x11		/*ML11 disk                         */
#define DT$_RB02 	0x12		/*R02 ON RB730                      */
#define DT$_RB80 	0x13		/*R80 ON RB730                      */
#define DT$_RA80 	0x14		/*R80 ON INTELLIGENT CONTROLLER     */
#define DT$_RA81 	0x15		/*R81 ON INTELLIGENT CONTROLLER     */
#define DT$_RA60 	0x16		/*PINON ON INTELLIGENT CONTROLLER   */
#define DT$_RZ01 	0x17		/*AZTEC REMOVABLE (Old name)        */
#define DT$_RC25 	0x17		/*AZTEC REMOVABLE (New name)        */
#define DT$_RZF01 	0x18		/*AZTEC FIXED (Old name)            */
#define DT$_RCF25 	0x18		/*AZTEC FIXED (New name)            */
#define DT$_RD51 	0x19		/*RD51 FIXED DISK DRIVE             */
#define DT$_RX50 	0x1A		/*RX50 FLOPPY DISK DRIVE            */
#define DT$_RD52 	0x1B		/*RD52 FIXED DISK DRIVE             */
#define DT$_RD53 	0x1C		/*RD53 FIXED DISK DRIVE             */
#define DT$_RD26 	0x1D		/*RD26 FIXED DISK DRIVE             */
#define DT$_RA82 	0x1E		/*RA82 FIXED DISK DRIVE             */
#define DT$_RC26 	0x1F		/*AZTEC II REMOVABLE                */
#define DT$_RCF26 	0x20		/*AZTEC II FIXED                    */
#define DT$_CRX50 	0x21		/*Console RX50                      */
#define DT$_RRD50 	0x22		/*RRD50                             */
#define DT$_RX31 	0x23		/*RX31                              */
#define DT$_RX32 	0x24		/*RX32                              */
#define DT$_RX18 	0x25		/*RX18                              */
#define DT$_FD1 	0x81		/*FOREIGN DISK TYPE 1               */
#define DT$_FD2 	0x82		/*FOREIGN DISK TYPE 2               */
#define DT$_FD3 	0x83		/*FOREIGN DISK TYPE 3               */
#define DT$_FD4 	0x84		/*FOREIGN DISK TYPE 4               */
#define DT$_FD5 	0x85		/*FOREIGN DISK TYPE 5               */
#define DT$_FD6 	0x86		/*FOREIGN DISK TYPE 6               */
#define DT$_FD7 	0x87		/*FOREIGN DISK TYPE 7               */
#define DT$_FD8 	0x88		/*FOREIGN DISK TYPE 8               */
/*                                                                          */
/* TAPE DEVICES                                                             */
/*                                                                          */
#define DT$_TE16 	0x01		/*TE16 MAGTAPE                      */
#define DT$_TU45 	0x02		/*TU45 MAGTAPE                      */
#define DT$_TU77 	0x03		/*TU77 MAGTAPE                      */
#define DT$_TS11 	0x04		/*TS11 MAGTAPE                      */
#define DT$_TU78 	0x05           /*TU78 MAGTAPE                      */
#define DT$_TA78 	0x06		/*TA78 MAGTAPE                      */
#define DT$_TU80 	0x07		/*TU80 MAGTAPE                      */
#define DT$_TU81 	0x08		/*TU81 MAGTAPE                      */
#define DT$_TA81 	0x09		/*TA81 MAGTAPE                      */
#define DT$_TK50 	0x0A		/*TK50 CARTRIDGE TAPE               */
#define DT$_MR_TU70 	0x0B		/*TU70 STC TAPE (DX20)              */
#define DT$_MR_TU72 	0x0C		/*TU72 STC TAPE                     */
/*                                                                          */
/* TERMINAL DEVICE TYPES                                                    */
/*                                                                          */
/* new definitions for terminal types should be placed in $ttdef only       */
/* this table remains around for compatibility only                         */
/*                                                                          */
/* **** MATCHES $TTDEF *****                                                */
#define DT$_TTYUNKN 	0x00		/* UNKNOWN TERMINAL                 */
#define DT$_VT05 	0x01		/* VT05                             */
#define DT$_FT1 	0x10		/* FOREIGN TERMINAL TYPES           */
#define DT$_FT2 	0x11
#define DT$_FT3 	0x12
#define DT$_FT4 	0x13
#define DT$_FT5 	0x14
#define DT$_FT6 	0x15
#define DT$_FT7 	0x16
#define DT$_FT8 	0x17		/* END OF FOREIGN TYPES             */
/* RESERVE REST UP TO 32 FOR EXTENSIONS                                     */
#define DT$_LAX 	0x20		/* LA TYPE TERMINAL                 */
#define DT$_LA36 	0x20		/* LA36                             */
#define DT$_LA120 	0x21
#define DT$_VT5X 	0x40		/* VT5X TYPE                        */
#define DT$_VT52 	0x40		/* VT52                             */
#define DT$_VT55 	0x41		/* VT55                             */
#define DT$_TQ_BTS 	0x04		/* TQ_BTS                           */
#define DT$_TEK401X 	0x0A		/* TEK401X series                   */
#define DT$_VT100 	0x60		/* VT100                            */
#define DT$_VK100 	0x02	
#define DT$_VT173 	0x03
#define DT$_LA34 	0x22
#define DT$_LA38 	0x23
#define DT$_LA12 	0x24
#define DT$_LA24 	0x25
#define DT$_LA100 	0x25
#define DT$_LQP02 	0x26
#define DT$_VT101 	0x61
#define DT$_VT102 	0x62
#define DT$_VT105 	0x63
#define DT$_VT125 	0x64
#define DT$_VT131 	0x65
#define DT$_VT132 	0x66
#define DT$_DZ11 	0x42		/* DZ11 CONTROLLER                  */
#define DT$_DZ32 	0x43		/* DZ32 CONTROLLER                  */
#define DT$_DZ730 	0x44		/* DZ730 (COMBO) CONTROLLER         */
#define DT$_DMZ32 	0x45		/* DMZ32 CONTROLLER                 */
#define DT$_DHV 	0x46		/* DHV CONTROLLER                   */
#define DT$_DHU 	0x47		/* DHU CONTROLLER                   */
#define DT$_SLU 	0x48		/* Onboard Serial Line Unit         */
/*                                                                          */
/* Terminal WORKSTATIONS                                                    */
/*                                                                          */
#define DT$_VS100 	0x01		/* VAXstation 100                   */
#define DT$_VS125 	0x02		/* VAXstation 125                   */
#define DT$_VS300 	0x03           	/* VAXstation 300                   */
#define DT$_VD 		0x04		/* VAXstation Vir. Device           */
/*                                                                          */
/* SYNCHRONOUS COMMUNICATIONS DEVICE TYPES                                  */
/*                                                                          */
#define DT$_DMC11 	0x01		/* DMC11                            */
#define DT$_DMR11 	0x02		/* DMR11                            */
#define DT$_XK_3271 	0x03		/* DUP-11 FOR 3271 PROTOCOL EMULATOR  */
#define DT$_XJ_2780 	0x04		/* DUP-11 FOR 2780 " "              */
#define DT$_NW_X25 	0x05		/* X25 PROTOCOL EMULATOR            */
#define DT$_NV_X29 	0x06		/* X29 " "                          */
#define DT$_SB_ISB11 	0x07		/* ISB-11 DEC dataway               */
#define DT$_MX_MUX200 	0x08		/* MUX-200 PROTOCOL EMULATOR        */
#define DT$_DMP11 	0x09		/* DMP11                            */
#define DT$_DMF32 	0x0A		/* DMF32                            */
#define DT$_XV_3271 	0x0B		/* DV-11 3271 PROTOCOL EMULATOR     */
#define DT$_CI 		0x0C		/* CI - Computer Interconnect       */
#define DT$_NI 		0x0D		/* NI - Network Interconnect        */
#define DT$_UNA11 	0x0E		/* UNIBUS to NI adapter             */
#define DT$_DEUNA 	0x0E		/* UNIBUS to NI adapter             */
#define DT$_YN_X25 	0x0F		/* KMS11 X.25 P. E.                 */
#define DT$_YO_X25 	0x10		/* " " "                            */
#define DT$_YP_ADCCP 	0x11		/* " ADCCP P.E.                     */
#define DT$_YQ_3271 	0x12		/* " " "                            */
#define DT$_YR_DDCMP 	0x13		/* " DDCMP                          */
#define DT$_YS_SDLC 	0x14		/* " SDLC                           */
#define DT$_UK_KTC32 	0x15		/* " KTC32                          */
#define DT$_DEQNA 	0x16		/* Q-BUS to NI adapter              */
#define DT$_DMV11 	0x17		/* DMV11                            */
#define DT$_ES_LANCE 	0x18		/* SCORPIO to NI adapter            */
#define DT$_DELUA 	0x19		/* LSI version of DEUNA             */
#define DT$_NQ_3271 	0x1A		/* DHCF                             */
#define DT$_DMB32 	0x1B		/* DMB32 (BICombo)                  */
#define DT$_YI_KMS11K 	0x1C		/* not a product, used by field service */
/*                                                                          */
/* LINE PRINTER AND CARD READER DEVICE TYPES                                */
/*                                                                          */
#define DT$_LP11 	0x01		/* LP11                             */
#define DT$_LA11 	0x02		/* LA11                             */
#define DT$_LA180 	0x03		/* LA180                            */
#define DT$_CR11 	0x01		/* CR11 CARD READER                 */
/*                                                                          */
/* MAILBOX DEVICE TYPES                                                     */
/*                                                                          */
#define DT$_MBX 	0x01		/* LOCAL MEMORY MAILBOX             */
#define DT$_SHRMBX 	0x02 		/* SHARED MEMORY MAILBOX            */
#define DT$_NULL 	0x03		/* The NULL DEVICE                  */
/*                                                                          */
/* REALTIME DEVICE TYPES                                                    */
/*                                                                          */
#define DT$_LPA11 	0x01		/* LPA-11                           */
#define DT$_DR780 	0x02            /* DR780                            */
#define DT$_DR750 	0x03		/* DR750                            */
#define DT$_DR11W 	0x04		/* DR11W                            */
#define DT$_PCL11R 	0x05		/* PCL11 RECEIVER (CSS)             */
#define DT$_PCL11T 	0x06		/* PCL11 TRANSMTTER (CSS)           */
#define DT$_DR11C 	0x07		/* DR11C PARALLEL INTERFACE         */
#define DT$_BS_DT07 	0x08		/* UNIBUS SWITCH                    */
#define DT$_XP_PCL11B 	0x09		/* PCL-11B (DECNET and NONDECNET mode CSS) */
#define DT$_IX_IEX11 	0x0A		/* IEEE-488 to UNIBUS INTERFACE     */
#define DT$_FP_FEPCM 	0x0B		/* FEPCM CSS frontend processor     */
#define DT$_TK_FCM 	0x0C		/* FEPCM CSS frontend processor     */
#define DT$_XI_DR11C 	0x0D		/* PARALLEL INTERFACE ON DMF-32     */
/*                                                                          */
/* BUS CLASS DEVICES                                                        */
/*                                                                          */
#define DT$_CI780 	0x01		/* CI780                            */
#define DT$_CI750 	0x02		/* CI750                            */
#define DT$_UQPORT 	0x03		/* UQPORT is generic UDA            */
#define DT$_UDA50 	0x03		/* UDA50                            */
#define DT$_UDA50A 	0x04		/* UDA50A                           */
#define DT$_LESI 	0x05		/* Low end storage                  */
#define DT$_TU81P 	0x06		/* TU81 port                        */
#define DT$_RDRX 	0x07		/* RDRX port                        */
#define DT$_TK50P 	0x08		/* TK50 port                        */
#define DT$_RUX50P 	0x09		/* RUX50 port                       */
#define DT$_RC26P 	0x0A		/* RC26P port                       */
#define DT$_QDA50 	0x0B		/* KDA50 port (old name)            */
#define DT$_KDA50 	0x0B		/* KDA50 port                       */
#define DT$_BDA50 	0x0C		/* KDB50 port (old name)            */
#define DT$_RRD50P 	0x0D		/* RRD50 port                       */
#define DT$_QDA25 	0x0E		/* KDA25 port (old name)            */
#define DT$_KDA25 	0x0E		/* KDA25 port                       */
#define DT$_BCI750 	0x0F		/* BI-CI750 port                    */
#define DT$_BCA 	0x10		/* BI-CI port                       */
#define DT$_RQDX3 	0x11		/* RQDX3 port                       */
/*	 								    */
/*  JOURNAL DEVICES							    */
/*									    */
#define DT$_UNKNJNL 	0x00		/*  UNKNOWN JOURNAL TYPE (ONLY IN TEMPLATE) */
#define DT$_RUJNL 	0x01		/*  RECOVERY UNIT JOURNAL   */
#define DT$_BIJNL 	0x02		/*  BEFORE IMAGE JOURNAL    */
#define DT$_AIJNL 	0x03		/*  AFTER IMAGE JOURNAL     */
#define DT$_ATJNL 	0x04		/*  AUDIT TRAIL JOURNAL     */
#define DT$_CLJNL 	0x05		/*  CONTROL JOURNAL 	    */
/*                                                                          */
/* MISCELLANEOUS DEVICES                                                    */
/*                                                                          */
#define DT$_DN11 	0x01		/* AUTODIALER                       */
 
