/*	PRCDEF 								    */
/*+                                                                         */
/* $CREPRC STATUS FLAGS AND ITEM CODES                                      */
/*-                                                                         */

#define PRC$M_SSRWAIT 1
#define PRC$M_SSFEXCU 2
#define PRC$M_PSWAPM 4
#define PRC$M_NOACNT 8
#define PRC$M_BATCH 16
#define PRC$M_HIBER 32
#define PRC$M_NOUAF 64
#define PRC$M_NETWRK 128
#define PRC$M_DISAWS 256
#define PRC$M_DETACH 512
#define PRC$M_INTER 1024
#define PRC$M_IMGDMP 2048
#define PRC$M_CLISPEC 4096
#define PRC$M_NOPASSWORD 8192
#define PRC$M_LOGIN 64
union prcdef {
    struct  {
        unsigned prc$v_ssrwait : 1;     /* RESOURCE WAIT DISABLE            */
        unsigned prc$v_ssfexcu : 1;     /* SYSTEM SERVICE FAIL EXCEPTION MODE  */
        unsigned prc$v_pswapm : 1;      /* PROCESS SWAP MODE                */
        unsigned prc$v_noacnt : 1;      /* ACCOUNTING MESSAGE DISABLE       */
        unsigned prc$v_batch : 1;       /* BATCH INDICATOR                  */
        unsigned prc$v_hiber : 1;       /* HIBERNATE BEFORE CALLING INITIAL IMAGE  */
        unsigned prc$v_nouaf : 1;       /* BYPASS LOGIN VERIFICATION FOR DETACHED PROC.  */
        unsigned prc$v_netwrk : 1;      /* NETWORK INDICATOR                */
        unsigned prc$v_disaws : 1;      /* DISABLE WORKING SET ADJUST       */
        unsigned prc$v_detach : 1;      /* DETACHED PROCESS                 */
        unsigned prc$v_inter : 1;       /* INTERACTIVE INDICATOR            */
        unsigned prc$v_imgdmp : 1;      /* IMAGE DUMP REQUESTED             */
        unsigned prc$v_clispec : 1;     /* PASS CLI SPECIFICATIONS          */
        unsigned prc$v_nopassword : 1;  /* DON'T PROMPT FOR USERNAME AND PASSWORD */
        unsigned prc$v_fill_10 : 2;
        } prc$r_prcdef_bits;
    struct  {
        unsigned prc$v_fill_0 : 6;
        unsigned prc$v_login : 1;       /* BYPASS LOGIN VERIFICATION FOR DETACHED PROC.  */
        unsigned prc$v_fill_11 : 1;
        } prc$r_prcdef_obsolete;
    } ;
/*+                                                                         */
/*                                                                          */
/* Create Process Item List Data Identifier Definitions                     */
/*                                                                          */
/* **** NOTE ****                                                           */
/*                                                                          */
/*        New items must always be added at the END of the list so that     */
/*        users will not have to relink or reassemble.                      */
/*                                                                          */
/*-                                                                         */
#define PRC$_LISTEND 0                  /* End of list (must be first code) */
#define PRC$_PGFLCHAR 1                 /* Page file characteristics        */
#define PRC$_PGFLINDEX 2                /* Page file index                  */
#define PRC$_INPUT_ATT 3                /* SYS$INPUT attributes             */
#define PRC$_OUTPUT_ATT 4               /* SYS$OUTPUT attributes            */
#define PRC$_ERROR_ATT 5                /* SYS$ERROR attributes             */
