/*	STDLIB - UNIX 'Standard I/O' Definitions 	 */
#include <stddef.h>

/* when a range error occurs errno gets this value */
#define	ERANGE	34		/* result too large */

/* largest floating point number */
#if CC$gfloat
# define HUGE_VAL 8.988465674311578540726371186585E+307
#else
# define HUGE_VAL 1.70141183460469229e38
#endif

/* max value returned by rand function */
#define RAND_MAX  2147473647

struct DIV_T {
    int quot,rem;
    };
typedef struct DIV_T div_t;

struct LDIV_T {
    long quot,rem;
    };
typedef struct LDIV_T ldiv_t;

double atof(const char *nptr);

int atoi(const char *nptr);

long int atol(const char *nptr);

double strtod(const char *nptr, char **endptr);

long int strtol(const char *nptr, char **endptr, int base);

unsigned long int strtoul(const char *nptr, char **endptr, int base );

int rand(void);

int srand(int seed);

void *calloc(size_t nmemb, size_t size);

int cfree (void *ptr);             /* NOTE return not ANSII */

int free (void *ptr);		   /* NOTE return not ANSII */

void *malloc(size_t size);

void *realloc(void *ptr, size_t size);

void abort(void);

void exit(int status);

char *getenv(const char *name);

int atexit(void (*func)(void));

int system(const char *string);

void *bsearch(const void *key, const void *base, size_t nmemb,
     	      size_t size, int (*compar)());

void qsort(void *base, size_t nmemb, size_t size,
     	   int (*compar)());

int abs(int j);

div_t div(int number, int denom);

long int labs(long int j);

ldiv_t ldiv(long int numer, long int denom);

