#ifndef __PKMATH
#define __PKMATH
/*	MATH - RTL Math Function Declarations	 */

double acos (double x);

double asin (double x);

double atan (double x);

double atan2 (double x, double y);

double cos (double x);

double sin (double x);

double tan (double x);

double cosh (double x);

double sinh (double x);

double tanh (double x);

double exp (double x);

double frexp (double value, int *exp);

double ldexp  (double x, int e);

double log (double x);

double log10 (double x);

double modf (double value, double *iptr);

double pow (double base, double exp);

double sqrt (double x);

double ceil (double x);

double fabs (double x);

struct CABS_T {double x, y;};
typedef struct CABS_T cabs_t;

double cabs (cabs_t z);

double hypot (double x, double y);

double floor (double x);

double fmod (double x, double y);

#if CC$gfloat
# define HUGE 8.988465674311578540726371186585E+307
#else
#define HUGE 1.70141183460469229e38
#endif

#include <errno.h>

#endif

