/*	STDIO - UNIX 'Standard I/O' Definitions 	 */

# ifndef __FILE
# define __FILE 1

#include <sys/types>
#include <sys$library:stddef.h>

# define _NFILE 20
# define BUFSIZ 512
# define _IONBF 0
# define _IOLBF 1
# define _IOFBF 2

	extern	struct	_iobuf
		{
		int	_cnt;
		char	*_ptr;
		char	*_base;
		char	_flag;

#define	_IOREAD		0x01
#define	_IOWRT		0x02
#define	_IONBF		0x04
#define	_IOMYBUF	0x08
#define	_IOEOF		0x10
#define	_IOERR		0x20
#define	_IOSTRG		0x40
#define _IORW		0x80

		char	_file;

		};

typedef struct _iobuf*	FILE;
typedef struct {unsigned : 32; unsigned : 32;} fpos_t;

extern noshare	FILE	*stdin, *stdout, *stderr;

#undef  NULL
#define	NULL		0
#define	EOF		(-1)
#define	TRUE		1
#define	FALSE		0

# define SEEK_SET 0
# define SEEK_CUR 1
# define SEEK_EOF 2
# define SEEK_END 2		/*  ANSI C definition */

# define OPEN_MAX 8
# define TMP_MAX  32

#define L_ctermid	64
#define L_cuserid	16
#define L_tmpnam	256
#define L_lcltmpnam	256
#define L_nettmpnam	256

#define getc(p)		fgetc(p)
#define getchar()	fgetc(stdin)
#define putc(x,p)	fputc(x,p)
#define putchar(x)	fputc(x,stdout)
#define feof(p)		(((*p)->_flag&_IOEOF)!=0)
#define ferror(p)	(((*p)->_flag&_IOERR)!=0)
#define fileno(p)	((*p)->_file)
#define clearerr(p)	((*p)->_flag &= ~(_IOERR|_IOEOF))

#define FILE_TYPE	struct _iobuf *

int fsetpos (FILE *file_ptr, const fpos_t *position);

int fgetpos (FILE *file_ptr, fpos_t *position);

char *fgetname (FILE *file_ptr, char *buffer, ...);

FILE *fopen (const char *filespec, const char *a_mode, ...);

FILE *fdopen (int file_desc, char *a_mode);

FILE *freopen (const char *file_spec, const char *a_mode, FILE *file_ptr, ...);

int fclose (FILE *file_ptr);

int fgetc (FILE *file_ptr);
int getw (FILE *file_ptr);

char *fgets (char *str, int maxchar, FILE *file_ptr);
char *gets  (char *str);

int fputs (const char *str, FILE *file_ptr);
int puts (char *str);

size_t fread (void *ptr, size_t size_of_item,
			size_t number_items, FILE *file_ptr);

size_t fwrite (void *ptr, size_t size_of_item,
			 size_t number_items, FILE *file_ptr);

int fscanf (FILE *file_ptr, const char *format_spec, ...);
int scanf  (const char *format_spec, ...);
int sscanf (char *str, const char *format_spec, ...);

int ungetc (int character, FILE *file_ptr);

int fprintf (FILE *file_ptr, const char *format_spec, ...);
int printf  (const char *format_spec, ...);
/* int sprintf (char *str, const char *format_spec, ...);*/

int fputc (int character, FILE *file_ptr);
int putw (int integer, FILE *file_ptr);

int fflush (FILE *file_ptr);

int fseek (FILE *file_ptr, int offset, int direction);

int ftell (FILE *file_ptr);

int rewind (FILE *file_ptr);

FILE *tmpfile (void);

char *tmpnam (char *name);

void setbuf (FILE *file_ptr, char *buffer);
int setvbuf (FILE *file_ptr, char *buffer, int type, size_t size);

int vfprintf (FILE *file_ptr, const char *format, void *arg);
int vprintf  (const char *format, void *arg);
int vsprintf (char *s, const char *format, void *arg);

#define random rand
#define srandom srand

# endif
